import { ProcfileReconciler } from './ProcfileReconciler';
import { CategoryReg, Entry } from '../domain';
import { ServiceRepresentationChainModifier } from './ServiceRepresentationChainModifier';
import { ProcessRepresentationChainModifier } from './ProcessRepresentationChainModifier';
/**
 * Class ProcfileReconcilerAccessor
 * A easy way to access ProcfileReconciler
 */
export declare class ProcfileReconcilerAccessor {
    private procfileReconciler;
    readonly dev: boolean;
    readonly appName: string;
    readonly appDir: string;
    constructor(procfileReconciler: ProcfileReconciler);
    defaultServiceCategory(name: CategoryReg): void;
    /**
     * Inject environment class
     * @param {Entry} entry
     */
    environment(entry: Entry): void;
    /**
     * define process
     * @param processName
     * @return {ProcessRepresentationChainModifier}
     */
    process(processName: string): ProcessRepresentationChainModifier;
    /**
     * Define fork a process
     * @param processName
     * @param entryFile
     * @return {ProcessRepresentationChainModifier}
     */
    fork(processName: string, entryFile: any): ProcessRepresentationChainModifier;
    /**
     * Inject service class
     * @param serviceName
     * @param serviceEntry
     * @return {ServiceRepresentationChainModifier}
     */
    service(serviceName: string, serviceEntry: any): ServiceRepresentationChainModifier;
    private clusterCount;
    /**
     * An alias to service()
     * @param path
     * @return {ServiceRepresentationChainModifier}
     */
    cluster(path: any): ServiceRepresentationChainModifier;
}
