import { ApplicationRepresentation, ComplexApplicationStructureRepresentation } from '../domain';
import { State } from '../const';
import { ApplicationHandler } from '../application/ApplicationHandler';
export declare class ComplexHandler {
    state: State;
    appId: string;
    appRepresentation: ApplicationRepresentation;
    mountedApplications: ApplicationHandler[];
    private startTime;
    private complexStructure;
    constructor(appRepresentation: ApplicationRepresentation);
    readonly name: string;
    readonly appDir: string;
    readonly mode: string;
    readonly pids: Array<number>;
    readonly startCount: number;
    readonly uptime: number;
    getComplex(): Promise<ComplexApplicationStructureRepresentation>;
    protected fillMounted(): Promise<void>;
    start(): Promise<void>;
    stop(): Promise<void>;
    reload(processName: string): Promise<void>;
    backupStdoutLogFile(): Promise<void>;
}
