"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const wrap = require("pandora-spawn-wrap");
const wrapFile = require.resolve('./spawnWrapper');
class SpawnWrapperUtils {
    static wrap() {
        if (!SpawnWrapperUtils.unwrapFn) {
            SpawnWrapperUtils.unwrapFn = wrap([wrapFile]);
        }
    }
    static unwrap() {
        if (SpawnWrapperUtils.unwrapFn) {
            this.unwrapFn();
            this.unwrapFn = null;
        }
    }
    static transaction(fn) {
        return __awaiter(this, void 0, void 0, function* () {
            SpawnWrapperUtils.wrap();
            let ret;
            let caughtError;
            try {
                ret = yield fn();
            }
            catch (error) {
                caughtError = error;
            }
            finally {
                SpawnWrapperUtils.unwrap();
            }
            if (caughtError) {
                throw caughtError;
            }
            return ret;
        });
    }
}
exports.SpawnWrapperUtils = SpawnWrapperUtils;
//# sourceMappingURL=SpawnWrapperUtils.js.map