'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
const ServiceReconciler_1 = require("../service/ServiceReconciler");
const WorkerContext_1 = require("../application/WorkerContext");
/**
 * Class DebugServiceReconciler
 * For Debugging Service
 */
class DebugServiceReconciler extends ServiceReconciler_1.ServiceReconciler {
    constructor(mode) {
        mode = mode || null;
        const processName = mode || 'worker';
        const process = {
            processName: processName,
            appName: 'pandora-debug',
            appDir: '/pandora-debug'
        };
        super(process, new WorkerContext_1.WorkerContext(process), mode);
    }
    receiveServiceRepresentation(rep) {
        if (rep.serviceEntry.dependencies && !rep.dependencies) {
            rep.dependencies = rep.serviceEntry.dependencies;
        }
        super.receiveServiceRepresentation(rep);
    }
}
exports.DebugServiceReconciler = DebugServiceReconciler;
//# sourceMappingURL=DebugServiceReconciler.js.map